// ===============================================================================
//						  AGEIA PHYSX SDK SAMPLE PROGRAMS
//					        TEST CLOTH IMPLEMENTATION
//
//		            Written by Matthias Mller-Fischer 03-08-05
// ===============================================================================

#ifndef MYCLOTH_H
#define MYCLOTH_H

#include <NxPhysics.h>

typedef struct _BBVERTEX
{
		float x,y,z;
	    float nx,ny,nz;
		char a,r,g,b;
		float u0,v0;
		float u1,v1;
		char i1,i2,i3,i4;
		float w1,w2,w3,w4;

} BBVERTEX, *LPBBVERTEX;
typedef struct _BBTRIANGE
{
         unsigned short a,b,c;

} BBTRIANGE, *LPBBTRIANGE;
typedef struct _IndexToIndex
{
	int sourceV, destV;

} IndexToIndex, *LIndexToIndex;
class MyCloth {
public:
	/* create regular mesh */
	//MyCloth(NxScene *scene, NxClothDesc &desc, struct _BBVERTEX* ThisVertex, int VertexCount, struct _BBTRIANGE* ThisTriangle, unsigned short int IndexCount);
	MyCloth(NxScene *scene, NxClothDesc &desc, unsigned long *surf, float *entity, float *vbank,int *fbank,int MESH_NBVERTICES,int MESH_NBFACES);
	//MyCloth(NxScene *scene, NxClothDesc &desc, float *vbank,float *fbank,int MESH_NBVERTICES,int MESH_NBFACES);
	float* entityData;
	unsigned long *surfData;
	NxActor* coreActor;
	LPBBVERTEX OldVertex;
	~MyCloth();

	int updateAllCloth(NxCloth*, float* entity, unsigned long *surf, LPBBVERTEX OldVertex);
	int updateAllUnitedCloth(NxCloth*, float* entity, unsigned long *surf, LPBBVERTEX OldVertex);
	void updateNormals(float* nbank);
	void updateTVertex(float* vbank);
	void updateTIndices(int* ibank);
	void updateTPIndices(int* ibank);
	int getNumVertices();
	int getNumIndices();
	NxCloth *getNxCloth() { return mCloth; }

	float* adresOldBuferVertexStart;
	float* adresOldBuferTriangleStart;
	float* adresOldBuferVertexEnd;
	float* adresOldBuferTriangleEnd;

	LPBBVERTEX FullBufferVertex;
	LPBBTRIANGE FullBufferTriangle;
	LIndexToIndex PointerIndexBuffer;
	int cDeltaTime;
	
private:
	void init(NxScene *scene, NxClothDesc &desc, NxClothMeshDesc &meshDesc);
	bool generateObjMeshDesc(NxClothMeshDesc &desc, char *filename, NxReal scale);
	void generateRegularMeshDesc(NxClothMeshDesc &desc, unsigned long *surf, float *entity, float *vbank,int *fbank,int MESH_NBVERTICES,int MESH_NBFACES);
	//void generateRegularMeshDescSpec(NxClothMeshDesc &desc, float *vbank,float *fbank,int MESH_NBVERTICES,int MESH_NBFACES);
	void generateTearLines(NxClothMeshDesc& desc, NxU32 w, NxU32 h);
	void releaseMeshDescBuffers(const NxClothMeshDesc& desc);

	bool cookMesh(NxClothMeshDesc& desc);

	void allocateReceiveBuffers(int numVertices, int numTriangles);
	void releaseReceiveBuffers();

	bool createTexture(char *filename);
	void updateTextureCoordinates();
	bool mInitDone;
	
	NxMeshData mReceiveBuffers;
	NxScene *mScene;
	NxCloth *mCloth;
	NxClothMesh *mClothMesh;

	float *mTexCoords;
	NxU32   mNumTexCoords;

//	GLuint  mTexId;
};

#endif
